;
; reg84.h
;
        LIST    p=16C84 ; PIC16C84 is the target processor
;
; 16C84 registers
;
;
; Registers
;
RegInd0		equ	00h
RegRtcc         equ     01h
RegOption       equ     01h
RegPcl          equ     02h
RegStatus       equ     03h
RegFsr		equ	04h
RegPorta        equ     05h
RegTrisa        equ     05h
RegPortb        equ     06h
RegTrisb        equ     06h
RegEEData	equ	08h	; Bank 0
RegEECon1	equ	08H	; Bank 1
RegEEAddr	equ	09h
RegIntcon       equ     0bh
;
; Flags
;
; RegOption
BitRts          equ     5
; RegStatus
BitIrp		equ	7
BitRp0          equ     5
BitZero         equ     2
BitDCarry	equ	1
BitCarry        equ     0
; RegEECon1
BitEERd		equ	0
; RegIntcon
BitGie          equ     7
BitRtie         equ     5
BitRbie         equ     3
BitRtif         equ     2
BitRbif         equ     0
;
; Macros
;
JMPNZ	MACRO	JumpLabel
	btfss	RegStatus,BitZero
	goto	JumpLabel
	ENDM
;
JMPZ	MACRO	JumpLabel
	btfsc	RegStatus,BitZero
	goto	JumpLabel
	ENDM
;
JMPNC	MACRO	JumpLabel
	btfss	RegStatus,BitCarry
	goto	JumpLabel
	ENDM
;
JMPC	MACRO	JumpLabel
	btfsc	RegStatus,BitCarry
	goto	JumpLabel
	ENDM
;
JMPNDC	MACRO	JumpLabel
	btfss	RegStatus,BitDCarry
	goto	JumpLabel
	ENDM
;
JMPDC	MACRO	JumpLabel
	btfsc	RegStatus,BitDCarry
	goto	JumpLabel
	ENDM
;


